/*** Sort directions ***/
 

#define increasing_sort_direction 0
#define decreasing_sort_direction 1



 /*** datatypes equates ***/

 #define dt_Byte_8                   0
 #define dt_Integer_32               1
 #define dt_Unsigned_Integer_32      2
 #define dt_Single_Precision_Real    3
 #define dt_Double_Precision_Real    4
 #define dt_Extended_Precision_Real  5
 #define dt_Integer_64               6
 
 #define dt_Pointer_32               7
 #define dt_Null_Terminated_String   8




;  Search  Functions "not found" constant

 #define not_found_constant  -1     



; returned status codes, in eax and the Status structure
; status_code field
 
 

 #define no_error                                       0
 
 #define null_pointer                                  -1
 #define void_array                                    -2
 #define void_compressed_grade_vector                  -3
 #define void_field                                    -4
 
 #define input_array_alignment_error                   -5
 #define grade_or_output_array_alignment_error         -6
 #define compressed_grade_vector_alignment_error       -7
 #define membership_vector_alignment_error             -8
 #define buffer_alignment_error                        -9
 
 #define input_array_wraparound                        -10
 #define grade_or_output_array_wraparound              -11
 #define buffer_wraparound -12
 #define overlapping_input_and_grade_or_output_arrays  -13
 #define buffer_and_input_array_overlap                -14
 #define buffer_and_grade_or_output_array_overlap      -15
 #define compressed_grade_vector_wraparound            -16
 #define membership_vector_wraparound                  -17
  
 #define input_array_length_limit_error                -18
 #define grade_vector_length_limit_error               -19
 #define row_length_limit_error                        -20
 #define byte_matrix_row_length_error                  -21
 #define field_length_limit_error                      -22
 #define incompatible_field_lengths                    -23
  
 #define invalid_datatype                              -24
 #define datatype_mismatch                             -25 
 #define first_field_datatype_mismatch   datatype_mismatch
 #define second_field_datatype_mismatch                -26
 
 #define invalid_compression_parameter                 -27

 #define invalid_first_compression_parameter            \
 invalid_compression_parameter

 #define invalid_second_compression_parameter          -28

 #define rank_or_structure_mismatch                    -29

 #define sort_direction_mismatch                       -30
  
 #define invalid_tuning_parameter                      -30

 #define NaN_or_unsupported_encoding                   -64


/*********************************************************/

 typedef unsigned char BYTE; 

 typedef signed char SBYTE;

 typedef unsigned int DWORD;

 typedef signed int SDWORD;

 typedef float REAL4;

 typedef double REAL8;

 typedef struct    /* or typedef unsigned __int64 QWORD */
 {
  DWORD low_dword;
  DWORD high_dword;
 }QWORD;

typedef struct    /* or typedef __int64 SQWORD */
 {
  DWORD low_dword;
  DWORD high_dword;
 }SQWORD;

 typedef struct
 {
  QWORD low_qword;
  QWORD high_qword;
 }DBL_QWORD;


 typedef BYTE Datatype;
 
 typedef DWORD Length_in_Bytes;

 typedef DWORD Length_in_Units;

 typedef DWORD Index;

 typedef DWORD Count;

 typedef DWORD Div_by_16_Remainder;

 typedef DWORD Enabled_if_0;

 typedef SDWORD Status_Code_errnz;

 typedef SBYTE Byte_Status_Code_errnz;

 typedef BYTE Inc_0_Dec_1;

 typedef Index *Indices_Vector;

 typedef void *Void_Pointer;

 typedef Void_Pointer User_Pointer; 

 typedef Void_Pointer Data_Pointer;

 typedef DBL_QWORD *Aligned_by_16;

 typedef REAL8 *Tuning_Parameter;

 typedef BYTE Padding_Byte;

 typedef DWORD Padding_Dword;
 

 typedef struct
 { 
  Length_in_Units vector_length;  
 } _Vector_Dimension; 

 typedef _Vector_Dimension *Vector_Dimension;


 typedef struct
 {
  Length_in_Units first_dimension;
  Length_in_Units row_length;
 } _Matrix_Dimensions;

 typedef _Matrix_Dimensions *Matrix_Dimensions;


  typedef struct
 { 
  Length_in_Units first_dimension; 
  Length_in_Units first_field_length; 
  Length_in_Units second_field_length;
 } _Composite_Matrix_Dimensions;

 typedef _Composite_Matrix_Dimensions *Composite_Matrix_Dimensions;


 
/********************************************************/

/*** Most C compilers' "long double" datatype is identical ***/
/*** to "double" (8 bytes) and differs from REAL10 (MASM) ***/ 
/*** extended precision real (10 bytes), FPU's internal format ***/

 typedef struct
 {
  BYTE extended_precision_real[10];
  Padding_Byte  padding[6];
 }REAL16;

 typedef struct
 {
  BYTE extended_precision_LexiFloat[11];
  Padding_Byte  padding;
 }LexiFloat;  


/********************************************************/


 typedef struct
 {
  Aligned_by_16       allocated_buffer;
  Enabled_if_0        real_time_clock_toggle;
  Status_Code_errnz   status_code; 
  Div_by_16_Remainder input_array_alignment;  
  Count               clocks_count_low_dword; 
  Count               clocks_count_high_dword; 
  Count               timer_ticks;
  Padding_Dword       padding[5];
 }Status;

 typedef Status *Status_Pointer;


/********************************************************/


 typedef struct
 {
  Padding_Dword     padding_dword_0;
  Padding_Dword     padding_dword_1;
  Status_Code_errnz status_code; 
  Count             NaNs_count;
  Count             unsupported_encodings_count;
  Count             positive_infinities_count;
  Count             negative_infinities_count;
  Count             denormals_count;
  Count             pseudo_denormals_count;
  Count             positive_zeroes_count;
  Count             negative_zeroes_count;
  Indices_Vector    NaNs_indices_array;  
 }Utilities_Status;

 typedef Utilities_Status *Utilities_Status_Pointer; 

 
/********************************************************/


 typedef struct
 {
  Length_in_Units compression_field_length;
  Index           grade_vector_first_occurrence_index;     
  Index           input_array_first_occurrence_index;
  Index           input_array_last_occurrence_index;
 }Compression_Record;


 typedef Compression_Record *Compression_Records_Vector; 

 #define compression_record_length  sizeof(Compression_Record)
 

/********************************************************/


 typedef struct
 {
  Data_Pointer               input_composite_matrix;
  Indices_Vector             grade_vector;
  Indices_Vector             membership_vector;
  Compression_Records_Vector compressed_grade_vector;
  Length_in_Units            compressed_grade_vector_length;
  Length_in_Units            first_compression_parameter;
  Length_in_Units            second_compression_parameter;
  Length_in_Units            first_dimension;
  Length_in_Units            first_field_length;
  Length_in_Units            second_field_length;
  Datatype                   first_field_datatype;
  Datatype                   second_field_datatype;
  Inc_0_Dec_1                sort_direction;
  Byte_Status_Code_errnz     status_code;
 }Composite_Compression_or_Search_Input;


 typedef Composite_Compression_or_Search_Input *c_s_i_Pointer;


 typedef Composite_Compression_or_Search_Input \
 Composite_Compression_Input;

 typedef Composite_Compression_or_Search_Input \
 Composite_Binary_Search_Left_Arg;
 
 typedef Composite_Compression_or_Search_Input \
 Composite_Binary_Search_Right_Arg;

 typedef Composite_Compression_or_Search_Input \ 
 Composite_Global_Search_Left_Arg;

 typedef Composite_Compression_or_Search_Input \
 Composite_Global_Search_Right_Arg;


/********************************************************/


 typedef struct
 {
  Data_Pointer               input_matrix;
  Indices_Vector             grade_vector;
  Indices_Vector             membership_vector;
  Compression_Records_Vector compressed_grade_vector;
  Length_in_Units            compressed_grade_vector_length;
  Length_in_Units            compression_parameter;
  Padding_Dword              padding_dword_0;
  Length_in_Units            first_dimension;
  Length_in_Units            row_length;
  Padding_Dword              padding_dword_1;
  Datatype                   datatype;
  Padding_Byte               padding_byte_0;
  Inc_0_Dec_1                sort_direction;
  Byte_Status_Code_errnz     status_code;
 }Matrix_Compression_or_Search_Input;

 typedef Matrix_Compression_or_Search_input *m_s_i_Pointer; 

 typedef Matrix_Compression_or_Search_Input \
 Matrix_Compression_Input;

 typedef Matrix_Compression_or_Search_Input \
 Matrix_Binary_Search_Left_Arg;
 
 typedef Matrix_Compression_or_Search_Input \
 Matrix_Binary_Search_Right_Arg;

 typedef Matrix_Compression_or_Search_Input \ 
 Matrix_Global_Search_Left_Arg;

 typedef Matrix_Compression_or_Search_Input \
 Matrix_Global_Search_Right_Arg;



/********************************************************/


 typedef struct
 {
  Data_Pointer               input_vector;
  Indices_Vector             grade_vector;
  Indices_Vector             membership_vector;
  Compression_Records_Vector compressed_grade_vector;
  Length_in_Units            compressed_grade_vector_length;
  Padding_Dword              padding_dword_0;
  Padding_Dword              padding_dword_1;
  Length_in_Units            input_vector_length;
  Padding_Dword              padding_dword_2;
  Padding_Dword              padding_dword_3;
  Datatype                   datatype;
  Padding_Byte               padding_byte_0;
  Inc_0_Dec_1                sort_direction;
  Byte_Status_Code_errnz     status_code;
 }Grade_Compression_or_Search_Input;

 typedef Grade_Compression_or_Search_Input *v_s_i_Pointer;


 typedef Grade_Compression_or_Search_Input \
 Grade_Compression_Input;

 typedef Grade_Compression_or_Search_Input \
 Grade_Binary_Search_Left_Arg;
 
 typedef Grade_Compression_or_Search_Input \
 Grade_Binary_Search_Right_Arg;

 typedef Grade_Compression_or_Search_Input \ 
 Grade_Global_Search_Left_Arg;

 typedef Grade_Compression_or_Search_Input \
 Grade_Global_Search_Right_Arg;


 
/********************************************************/


typedef int __stdcall Comparison_Function\
 (User_Pointer left_argument,User_Pointer right_argument);

 typedef Comparison_Function *Comparison_Function_ptr;


typedef int __stdcall InPlace_Call_fn\ 
 (Tuning_Parameter,\
  Comparison_Function_ptr,\
  Status_Pointer,\
  Vector_Dimension,\
  User_Pointer *input_output_array);         

 typedef InPlace_Call_fn *InPlace_Call_fn_ptr;


 typedef int __stdcall Grade_Call_fn\
 (Tuning_Parameter,\
  Comparison_Function_ptr,\
  Status_Pointer,\
  Vector_Dimension,\
  User_Pointer *input_array,\
  Indices_Vector grade_vector);

 typedef Grade_Call_fn *Grade_Call_fn_ptr;


 typedef int __stdcall C_Grade_Call_fn\
 (Comparison_Function_ptr,Grade_Compression_Input *);

 typedef C_Grade_Call_fn *C_Grade_Call_fn_ptr;
 

 typedef int __stdcall B_Grade_Call_fn\
 (Comparison_Function_ptr,\
  Grade_Binary_Search_Left_Arg *,\
  Grade_Binary_Search_Right_Arg *);

 typedef B_Grade_Call_fn *B_Grade_Call_fn_ptr;


 typedef int __stdcall S_Grade_Call_fn\
 (Comparison_Function_ptr,\
 Grade_Global_Search_Left_Arg *,\
 Grade_Global_Search_Right_Arg *);

 typedef S_Grade_Call_fn *S_Grade_Call_fn_ptr;





 typedef int __stdcall InPlace_fn\ 
 (Tuning_Parameter,\
  Status_Pointer,\
  Vector_Dimension,\
  Data_Pointer input_output_array);
 

 typedef InPlace_fn *InPlace_fn_ptr;



 typedef int __stdcall Direct_fn\ 
 (Status_Pointer,\
  Vector_Dimension,\
  Data_Pointer input_array,\
  Data_Pointer output_array); 


 typedef Direct_fn *Direct_fn_ptr;





 typedef int __stdcall Grade_fn\ 
 (Status_Pointer,\
  Vector_Dimension,\
  Data_Pointer input_array,\
  Indices_Vector grade_vector); 

 typedef Grade_fn *Grade_fn_ptr;

 typedef int __stdcall C_Grade_fn\
 (Grade_Compression_Input *);

 typedef C_Grade_fn *C_Grade_fn_ptr;

 typedef int __stdcall B_Grade_fn\
 (Grade_Binary_Search_Left_Arg *,\
  Grade_Binary_Search_Right_Arg *);

 typedef B_Grade_fn *B_Grade_fn_ptr;

 typedef int __stdcall S_Grade_fn\
 (Grade_Global_Search_Left_Arg *,\
  Grade_Global_Search_Right_Arg *);

 typedef S_Grade_fn *S_Grade_fn_ptr; 




 typedef int __stdcall Matrix_fn\ 
 (Status_Pointer,\
  Matrix_Dimensions,\
  Data_Pointer input_array,\
  Indices_Vector grade_vector); 

 typedef Matrix_fn *Matrix_fn_ptr;


 typedef int __stdcall C_Matrix_fn\
 (Matrix_Compression_Input *);

 typedef C_Matrix_fn *C_Matrix_fn_ptr;

 typedef int __stdcall B_Matrix_fn\
 (Matrix_Binary_Search_Left_Arg *,\
  Matrix_Binary_Search_Right_Arg *);

 typedef B_Matrix_fn *B_Matrix_fn_ptr;

 typedef int __stdcall S_Matrix_fn\
 (Matrix_Global_Search_Left_Arg *,\
  Matrix_Global_Search_Right_Arg *);

 typedef S_Matrix_fn *S_Matrix_fn_ptr; 




 typedef int __stdcall Composite_fn\ 
 (Status_Pointer,\
  Composite_Matrix_Dimensions,\
  Data_Pointer input_array,\
  Indices_Vector grade_vector); 

 typedef Composite_fn *Composite_fn_ptr;


 typedef int __stdcall C_Composite_fn\
 (Composite_Compression_Input *);

 typedef C_Composite_fn *C_Composite_fn_ptr;

 typedef int __stdcall B_Composite_fn\
 (Composite_Binary_Search_Left_Arg *,\
  Composite_Binary_Search_Right_Arg *);

 typedef B_Composite_fn *B_Composite_fn_ptr;

 typedef int __stdcall S_Composite_fn\
 (Composite_Global_Search_Left_Arg *,\
  Composite_Global_Search_Right_Arg *);

 typedef S_Composite_fn *S_Composite_fn_ptr; 

 

/********************************************************************/
 


 typedef int __stdcall Reorder_Array_fn\
 (Utilities_Status_Pointer,\
  Void_Pointer source_array,\
  Void_Pointer destination_array,\
  Indices_Vector indices_array,\
  Length_in_Units indices_array_length,\
  Length_in_Bytes unit_length);

 typedef Reorder_Array_fn *Reorder_Array_fn_ptr;



 typedef int __stdcall Link_Array_fn\
 (Utilities_Status_Pointer,\
  Length_in_Units array_first_dimension,\
  Length_in_Units compressed_grade_vector_length,\
  Indices_Vector grade_vector,\
  Compression_Records_Vector compressed_grade_vector,\
  Indices_Vector link_array);

 typedef Link_Array_fn *Link_Array_fn_ptr;

 

typedef int __stdcall DQword_Transpose_fn\
 (Utilities_Status_Pointer,\
  DBL_QWORD *source_array,\
  DBL_QWORD *destination_array,\
  Length_in_Units first_dimension,\
  Length_in_Units row_length);

 typedef DQword_Transpose_fn *DQword_Transpose_fn_ptr;

  
 typedef int __stdcall Qword_Transpose_fn\
 (Utilities_Status_Pointer,\
  QWORD *source_array,\
  QWORD *destination_array,\
  Length_in_Units first_dimension,\
  Length_in_Units row_length);

 typedef Qword_Transpose_fn *Qword_Transpose_fn_ptr;


 typedef int __stdcall Dword_Transpose_fn\
 (Utilities_Status_Pointer,\
  DWORD *source_array,\
  DWORD *destination_array,\
  Length_in_Units first_dimension,\
  Length_in_Units row_length);

 typedef Dword_Transpose_fn *Dword_Transpose_fn_ptr;
  

 typedef int __stdcall Byte_Transpose_fn\
 (Utilities_Status_Pointer,\
  BYTE *source_array,\
  BYTE *destination_array,\
  Length_in_Units first_dimension,\
  Length_in_Units row_length);

 typedef Byte_Transpose_fn *Byte_Transpose_fn_ptr;

 

  /* ScanFloat_Composite_Real10,ScanFloat_Composite_Real8
     and ScanFloat_Composite_Real4 */

 typedef int __stdcall ScanFloat_Composite_fn\
 (Utilities_Status_Pointer,\
  Void_Pointer input_array,\
  Length_in_Units input_array_first_dimension,\
  Length_in_Bytes row_length,\
  SDWORD pos_or_neg_field_length_in_units);

 typedef ScanFloat_Composite_fn \
 *ScanFloat_Composite_fn_ptr; 



 typedef int __stdcall ScanFloat_Vector_Real10_fn\
 (Utilities_Status_Pointer,\
  REAL16 *input_vector,\
  Length_in_Units vector_length);

 typedef ScanFloat_Vector_Real10_fn *ScanFloat_Vector_Real10_fn_ptr;



 typedef int __stdcall ScanFloat_Vector_Real8_fn\
 (Utilities_Status_Pointer,\
  REAL8 *input_vector,\
  Length_in_Units vector_length);

 typedef ScanFloat_Vector_Real8_fn *ScanFloat_Vector_Real8_fn_ptr;
 

  
 typedef int __stdcall ScanFloat_Vector_Real4_fn\
 (Utilities_Status_Pointer,\
  REAL4 *input_vector,\
  Length_in_Units vector_length);

 typedef ScanFloat_Vector_Real4_fn *ScanFloat_Vector_Real4_fn_ptr;



 typedef int __stdcall CleanFloat_Real10_fn\
 (Utilities_Status_Pointer,\
  REAL16 *Real10_Vector,\
  Length_in_Units Real10_Vector_Length);

  
 typedef CleanFloat_Real10_fn *CleanFloat_Real10_fn_ptr; 


 typedef int __stdcall CleanFloat_Real8_fn\
 (Utilities_Status_Pointer,\
  REAL8 *Real8_Vector,\
  Length_in_Units Real8_Vector_Length);
  
 typedef CleanFloat_Real8_fn *CleanFloat_Real8_fn_ptr; 

 
 typedef int __stdcall CleanFloat_Real4_fn\
 (Utilities_Status_Pointer,\
  REAL4 *Real4_Vector,\
  Length_in_Units Real4_Vector_Length);

  
 typedef CleanFloat_Real4_fn *CleanFloat_Real4_fn_ptr;



 
 typedef int __stdcall Real10_to_LexiFloat_fn\
 (Utilities_Status_Pointer,\
  REAL16 *Real10_Vector,\
  LexiFloat *LexiFloat_Matrix,\
  Length_in_Units Real10_Vector_Length);

 typedef Real10_to_LexiFloat_fn *Real10_to_LexiFloat_fn_ptr;


 typedef int __stdcall LexiFloat_to_Real10_fn\
 (Utilities_Status_Pointer,\
  LexiFloat *LexiFloat_Matrix,\
  REAL16 *Real10_Vector,\
  Length_in_Units LexiFloat_Matrix_first_dimension);

 typedef LexiFloat_to_Real10_fn *LexiFloat_to_Real10_fn_ptr;



 typedef int __stdcall Real8_to_LexiFloat_fn\
 (Utilities_Status_Pointer,\
  REAL8 *Real8_Vector,\
  LexiFloat *LexiFloat_Matrix,\
  Length_in_Units Real8_Vector_Length);

 typedef Real8_to_LexiFloat_fn *Real8_to_LexiFloat_fn_ptr;


 typedef int __stdcall LexiFloat_to_Real8_fn\
 (Utilities_Status_Pointer,\
  LexiFloat *LexiFloat_Matrix,\
  REAL8 *Real8_Vector,\
  Length_in_Units LexiFloat_Matrix_first_dimension);

 typedef LexiFloat_to_Real8_fn *LexiFloat_to_Real8_fn_ptr;
 


 typedef int __stdcall Real4_to_LexiFloat_fn\
 (Utilities_Status_Pointer,\
  REAL4 *Real4_Vector,\
  LexiFloat *LexiFloat_Matrix,\
  Length_in_Units Real4_Vector_Length);

 typedef Real4_to_LexiFloat_fn *Real4_to_LexiFloat_fn_ptr;


 typedef int __stdcall LexiFloat_to_Real4_fn\
 (Utilities_Status_Pointer,\
  LexiFloat *LexiFloat_Matrix,\
  REAL4 *Real4_Vector,\
  Length_in_Units LexiFloat_Matrix_first_dimension);

 typedef LexiFloat_to_Real4_fn *LexiFloat_to_Real4_fn_ptr;
